import { FC, useState } from "react";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import htmr from "htmr";
import React from "react";
import { faAngleDown, faAngleUp } from "@fortawesome/free-solid-svg-icons";

type RuleExpanderProps = {
  title: string;
  body: string;
};

export const RuleExpander: FC<RuleExpanderProps> = ({ title, body }) => {
  const [expanded, setExpanded] = useState(false);
  const flipExpanded = () => setExpanded(!expanded);

  return (
    <article className="ruleExpander">
      <div className="heading" onClick={flipExpanded}>
        <h3>{title}</h3>
        <span>
          <FontAwesomeIcon
            icon={expanded ? faAngleUp : faAngleDown}
            size="lg"
          />
        </span>
      </div>
      <div
        className="contentWrapper"
        style={{ display: expanded ? "block" : "none" }}
      >
        <div className="content">{htmr(body)}</div>
        <div className="unexpand" onClick={flipExpanded}>
          <FontAwesomeIcon icon={faAngleUp} size="3x" />
        </div>
      </div>
    </article>
  );
};
