import { Language } from "../types/Language";

export const AppPageState = {
  master: "master",
  detail: "detail",
  conMap: "conMap",
} as const;

export type AppPageState = (typeof AppPageState)[keyof typeof AppPageState];

export type AppState = [Language, AppPageState, number, string];

export const appStateParse = (hashes: string): AppState | undefined => {
  const beenSplit = hashes.split("#");
  if (beenSplit.length != 4) {
    return undefined;
  }
  return [
    beenSplit[0] as Language,
    beenSplit[1] as AppPageState,
    parseInt(beenSplit[2]),
    beenSplit[3],
  ];
};

export const appStateSerialize = (data: AppState): string =>
  data.map((x) => String(x)).join("#");
